## android-platform-build 6.0.1+r16

=== Makefile ===
# Put some miscellaneous rules here

# HACK: clear LOCAL_PATH from including last build target before calling
# intermedites-dir-for
LOCAL_PATH := $(BUILD_SYSTEM)

# Pick a reasonable string to use to identify files.
ifneq "" "$(filter eng.%,$(BUILD_NUMBER))"
  # BUILD_NUMBER has a timestamp in it, which means that
  # it will change every time.  Pick a stable value.
  FILE_NAME_TAG := eng.$(USER)
else
  FILE_NAME_TAG := $(BUILD_NUMBER)
endif

# -----------------------------------------------------------------
# Define rules to copy PRODUCT_COPY_FILES defined by the product.
# PRODUCT_COPY_FILES contains words like <source file>:<dest file>[:<owner>].
# <dest file> is relative to $(PRODUCT_OUT), so it should look like,
# e.g., "system/etc/file.xml".
# The filter part means "only eval the copy-one-file rule if this
# src:dest pair is the first one to match the same dest"
#$(1): the src:dest pair
define check-product-copy-files
$(if $(filter %.apk, $(call word-colon, 2, $(1))),$(error \
    Prebuilt apk found in PRODUCT_COPY_FILES: $(1), use BUILD_PREBUILT instead!))
endef
# filter out the duplicate <source file>:<dest file> pairs.
unique_product_copy_files_pairs :=
$(foreach cf,$(PRODUCT_COPY_FILES), \
    $(if $(filter $(unique_product_copy_files_pairs),$(cf)),,\
        $(eval unique_product_copy_files_pairs += $(cf))))
unique_product_copy_files_destinations :=
$(foreach cf,$(unique_product_copy_files_pairs), \
    $(eval _src := $(call word-colon,1,$(cf))) \
    $(eval _dest := $(call word-colon,2,$(cf))) \
    $(call check-product-copy-files,$(cf)) \
    $(if $(filter $(unique_product_copy_files_destinations),$(_dest)), \
        $(info PRODUCT_COPY_FILES $(cf) ignored.), \
        $(eval _fulldest := $(call append-path,$(PRODUCT_OUT),$(_dest))) \
        $(if $(filter %.xml,$(_dest)),\
            $(eval $(call copy-xml-file-checked,$(_src),$(_fulldest))),\
            $(eval $(call copy-one-file,$(_src),$(_fulldest)))) \
        $(eval ALL_DEFAULT_INSTALLED_MODULES += $(_fulldest)) \
        $(eval unique_product_copy_files_destinations += $(_dest))))
unique_product_copy_files_pairs :=
unique_product_copy_files_destinations :=

# -----------------------------------------------------------------
# docs/index.html
ifeq (,$(TARGET_BUILD_APPS))
gen := $(OUT_DOCS)/index.html
ALL_DOCS += $(gen)
$(gen): frameworks/base/docs/docs-redirect-index.html
	@mkdir -p $(dir $@)
	@cp -f $< $@
endif

# -----------------------------------------------------------------
# default.prop
INSTALLED_DEFAULT_PROP_TARGET := $(TARGET_ROOT_OUT)/default.prop
ALL_DEFAULT_INSTALLED_MODULES += $(INSTALLED_DEFAULT_PROP_TARGET)
ADDITIONAL_DEFAULT_PROPERTIES := \
    $(call collapse-pairs, $(ADDITIONAL_DEFAULT_PROPERTIES))
ADDITIONAL_DEFAULT_PROPERTIES += \
    $(call collapse-pairs, $(PRODUCT_DEFAULT_PROPERTY_OVERRIDES))
ADDITIONAL_DEFAULT_PROPERTIES := $(call uniq-pairs-by-first-component, \
    $(ADDITIONAL_DEFAULT_PROPERTIES),=)

intermediate_system_build_prop := $(call intermediates-dir-for,ETC,system_build_prop)/build.prop

$(INSTALLED_DEFAULT_PROP_TARGET): $(intermediate_system_build_prop)
	@echo Target buildinfo: $@
	@mkdir -p $(dir $@)
	$(hide) echo "#" > $@; \
	        echo "# ADDITIONAL_DEFAULT_PROPERTIES" >> $@; \
	        echo "#" >> $@;
	$(hide) $(foreach line,$(ADDITIONAL_DEFAULT_PROPERTIES), \
		echo "$(line)" >> $@;)
	$(hide) echo "#" >> $@; \
	        echo "# BOOTIMAGE_BUILD_PROPERTIES" >> $@; \
	        echo "#" >> $@;
	$(hide) echo ro.bootimage.build.date=`date`>>$@
	$(hide) echo ro.bootimage.build.date.utc=`date +%s`>>$@
	$(hide) echo ro.bootimage.build.fingerprint="$(BUILD_FINGERPRINT)">>$@
	$(hide) build/tools/post_process_props.py $@

# -----------------------------------------------------------------
# build.prop
INSTALLED_BUILD_PROP_TARGET := $(TARGET_OUT)/build.prop
ALL_DEFAULT_INSTALLED_MODULES += $(INSTALLED_BUILD_PROP_TARGET)
ADDITIONAL_BUILD_PROPERTIES := \
    $(call collapse-pairs, $(ADDITIONAL_BUILD_PROPERTIES))
ADDITIONAL_BUILD_PROPERTIES := $(call uniq-pairs-by-first-component, \
    $(ADDITIONAL_BUILD_PROPERTIES),=)

# A list of arbitrary tags describing the build configuration.
# Force ":=" so we can use +=
BUILD_VERSION_TAGS := $(BUILD_VERSION_TAGS)
ifeq ($(TARGET_BUILD_TYPE),debug)
  BUILD_VERSION_TAGS += debug
endif
# The "test-keys" tag marks builds signed with the old test keys,
# which are available in the SDK.  "dev-keys" marks builds signed with
# non-default dev keys (usually private keys from a vendor directory).
# Both of these tags will be removed and replaced with "release-keys"
# when the target-files is signed in a post-build step.
ifeq ($(DEFAULT_SYSTEM_DEV_CERTIFICATE),build/target/product/security/testkey)
BUILD_KEYS := test-keys
else
BUILD_KEYS := dev-keys
endif
BUILD_VERSION_TAGS += $(BUILD_KEYS)
BUILD_VERSION_TAGS := $(subst $(space),$(comma),$(sort $(BUILD_VERSION_TAGS)))

# A human-readable string that descibes this build in detail.
build_desc := $(TARGET_PRODUCT)-$(TARGET_BUILD_VARIANT) $(PLATFORM_VERSION) $(BUILD_ID) $(BUILD_NUMBER) $(BUILD_VERSION_TAGS)
$(intermediate_system_build_prop): PRIVATE_BUILD_DESC := $(build_desc)

# The string used to uniquely identify the combined build and product; used by the OTA server.
ifeq (,$(strip $(BUILD_FINGERPRINT)))
  ifneq ($(filter eng.%,$(BUILD_NUMBER)),)
    # Trim down BUILD_FINGERPRINT: the default BUILD_NUMBER makes it easily exceed
    # the Android system property length limit (PROPERTY_VALUE_MAX=92).
    BF_BUILD_NUMBER := $(USER)$(shell date +%m%d%H%M)
  else
    BF_BUILD_NUMBER := $(BUILD_NUMBER)
  endif
  BUILD_FINGERPRINT := $(PRODUCT_BRAND)/$(TARGET_PRODUCT)/$(TARGET_DEVICE):$(PLATFORM_VERSION)/$(BUILD_ID)/$(BF_BUILD_NUMBER):$(TARGET_BUILD_VARIANT)/$(BUILD_VERSION_TAGS)
endif
ifneq ($(words $(BUILD_FINGERPRINT)),1)
  $(error BUILD_FINGERPRINT cannot contain spaces: "$(BUILD_FINGERPRINT)")
endif

# The string used to uniquely identify the system build; used by the OTA server.
# This purposefully excludes any product-specific variables.
ifeq (,$(strip $(BUILD_THUMBPRINT)))
  BUILD_THUMBPRINT := $(PLATFORM_VERSION)/$(BUILD_ID)/$(BUILD_NUMBER):$(TARGET_BUILD_VARIANT)/$(BUILD_VERSION_TAGS)
endif
ifneq ($(words $(BUILD_THUMBPRINT)),1)
  $(error BUILD_THUMBPRINT cannot contain spaces: "$(BUILD_THUMBPRINT)")
endif

KNOWN_OEM_THUMBPRINT_PROPERTIES := \
    ro.product.brand \
    ro.product.name \
    ro.product.device
OEM_THUMBPRINT_PROPERTIES := $(filter $(KNOWN_OEM_THUMBPRINT_PROPERTIES),\
    $(PRODUCTS.$(INTERNAL_PRODUCT).PRODUCT_OEM_PROPERTIES))

# Display parameters shown under Settings -> About Phone
ifeq ($(TARGET_BUILD_VARIANT),user)
  # User builds should show:
  # release build number or branch.buld_number non-release builds

  # Dev. branches should have DISPLAY_BUILD_NUMBER set
  ifeq "true" "$(DISPLAY_BUILD_NUMBER)"
    BUILD_DISPLAY_ID := $(BUILD_ID).$(BUILD_NUMBER) $(BUILD_KEYS)
  else
    BUILD_DISPLAY_ID := $(BUILD_ID) $(BUILD_KEYS)
  endif
else
  # Non-user builds should show detailed build information
  BUILD_DISPLAY_ID := $(build_desc)
endif

# Accepts a whitespace separated list of product locales such as
# (en_US en_AU en_GB...) and returns the first locale in the list with
# underscores replaced with hyphens. In the example above, this will
# return "en-US".
define get-default-product-locale
$(strip $(subst _,-, $(firstword $(1))))
endef

BUILDINFO_SH := build/tools/buildinfo.sh

ifdef TARGET_SYSTEM_PROP
system_prop_file := $(TARGET_SYSTEM_PROP)
else
system_prop_file := $(wildcard $(TARGET_DEVICE_DIR)/system.prop)
endif
$(intermediate_system_build_prop): $(BUILDINFO_SH) $(INTERNAL_BUILD_ID_MAKEFILE) $(BUILD_SYSTEM)/version_defaults.mk $(system_prop_file) $(INSTALLED_ANDROID_INFO_TXT_TARGET)
	@echo Target buildinfo: $@
	@mkdir -p $(dir $@)
	$(hide) echo > $@
ifneq ($(PRODUCTS.$(INTERNAL_PRODUCT).PRODUCT_OEM_PROPERTIES),)
	$(hide) echo "#" >> $@; \
	        echo "# PRODUCT_OEM_PROPERTIES" >> $@; \
	        echo "#" >> $@;
	$(hide) $(foreach prop,$(PRODUCTS.$(INTERNAL_PRODUCT).PRODUCT_OEM_PROPERTIES), \
		echo "import /oem/oem.prop $(prop)" >> $@;)
endif
	$(hide) TARGET_BUILD_TYPE="$(TARGET_BUILD_VARIANT)" \
			TARGET_BUILD_FLAVOR="$(TARGET_PRODUCT)-$(TARGET_BUILD_VARIANT)" \
			TARGET_DEVICE="$(TARGET_DEVICE)" \
			PRODUCT_NAME="$(TARGET_PRODUCT)" \
			PRODUCT_BRAND="$(PRODUCT_BRAND)" \
			PRODUCT_DEFAULT_LOCALE="$(call get-default-product-locale,$(PRODUCT_LOCALES))" \
			PRODUCT_DEFAULT_WIFI_CHANNELS="$(PRODUCT_DEFAULT_WIFI_CHANNELS)" \
			PRODUCT_MODEL="$(PRODUCT_MODEL)" \
			PRODUCT_MANUFACTURER="$(PRODUCT_MANUFACTURER)" \
			PRIVATE_BUILD_DESC="$(PRIVATE_BUILD_DESC)" \
			BUILD_ID="$(BUILD_ID)" \
			BUILD_DISPLAY_ID="$(BUILD_DISPLAY_ID)" \
			BUILD_NUMBER="$(BUILD_NUMBER)" \
			PLATFORM_VERSION="$(PLATFORM_VERSION)" \
			PLATFORM_SECURITY_PATCH="$(PLATFORM_SECURITY_PATCH)" \
			PLATFORM_BASE_OS="$(PLATFORM_BASE_OS)" \
			PLATFORM_SDK_VERSION="$(PLATFORM_SDK_VERSION)" \
			PLATFORM_PREVIEW_SDK_VERSION="$(PLATFORM_PREVIEW_SDK_VERSION)" \
			PLATFORM_VERSION_CODENAME="$(PLATFORM_VERSION_CODENAME)" \
			PLATFORM_VERSION_ALL_CODENAMES="$(PLATFORM_VERSION_ALL_CODENAMES)" \
			BUILD_VERSION_TAGS="$(BUILD_VERSION_TAGS)" \
			TARGET_BOOTLOADER_BOARD_NAME="$(TARGET_BOOTLOADER_BOARD_NAME)" \
			BUILD_FINGERPRINT="$(BUILD_FINGERPRINT)" \
			$(if $(OEM_THUMBPRINT_PROPERTIES),BUILD_THUMBPRINT="$(BUILD_THUMBPRINT)") \
			TARGET_BOARD_PLATFORM="$(TARGET_BOARD_PLATFORM)" \
			TARGET_CPU_ABI_LIST="$(TARGET_CPU_ABI_LIST)" \
			TARGET_CPU_ABI_LIST_32_BIT="$(TARGET_CPU_ABI_LIST_32_BIT)" \
			TARGET_CPU_ABI_LIST_64_BIT="$(TARGET_CPU_ABI_LIST_64_BIT)" \
			TARGET_CPU_ABI="$(TARGET_CPU_ABI)" \
			TARGET_CPU_ABI2="$(TARGET_CPU_ABI2)" \
			TARGET_AAPT_CHARACTERISTICS="$(TARGET_AAPT_CHARACTERISTICS)" \
	        bash $(BUILDINFO_SH) >> $@
	$(hide) $(foreach file,$(system_prop_file), \
		if [ -f "$(file)" ]; then \
			echo "#" >> $@; \
			echo Target buildinfo from: "$(file)"; \
			echo "# from $(file)" >> $@; \
			echo "#" >> $@; \
			cat $(file) >> $@; \
		fi;)
	$(if $(ADDITIONAL_BUILD_PROPERTIES), \
		$(hide) echo >> $@; \
		        echo "#" >> $@; \
		        echo "# ADDITIONAL_BUILD_PROPERTIES" >> $@; \
		        echo "#" >> $@; )
	$(hide) $(foreach line,$(ADDITIONAL_BUILD_PROPERTIES), \
		echo "$(line)" >> $@;)
	$(hide) cat $(INSTALLED_ANDROID_INFO_TXT_TARGET) | grep 'require version-' | sed -e 's/require version-/ro.build.expect./g' >> $@
	$(hide) build/tools/post_process_props.py $@ $(PRODUCTS.$(INTERNAL_PRODUCT).PRODUCT_SYSTEM_PROPERTY_BLACKLIST)

build_desc :=

ifeq (,$(filter true, $(TARGET_NO_KERNEL) $(TARGET_NO_RECOVERY)))
INSTALLED_RECOVERYIMAGE_TARGET := $(PRODUCT_OUT)/recovery.img
else
INSTALLED_RECOVERYIMAGE_TARGET :=
endif

$(INSTALLED_BUILD_PROP_TARGET): $(intermediate_system_build_prop) $(INSTALLED_RECOVERYIMAGE_TARGET)
	@echo "Target build info: $@"
	$(hide) cat $(intermediate_system_build_prop) > $@
ifdef INSTALLED_RECOVERYIMAGE_TARGET
	$(hide) echo ro.expect.recovery_id=`cat $(RECOVERYIMAGE_ID_FILE)` >> $@
endif

# -----------------------------------------------------------------
# vendor build.prop
#
# For verifying that the vendor build is what we thing it is
ifdef BOARD_VENDORIMAGE_FILE_SYSTEM_TYPE
INSTALLED_VENDOR_BUILD_PROP_TARGET := $(TARGET_OUT_VENDOR)/build.prop
ALL_DEFAULT_INSTALLED_MODULES += $(INSTALLED_VENDOR_BUILD_PROP_TARGET)
$(INSTALLED_VENDOR_BUILD_PROP_TARGET): $(INSTALLED_BUILD_PROP_TARGET)
	@echo Target vendor buildinfo: $@
	@mkdir -p $(dir $@)
	$(hide) echo > $@
	$(hide) echo ro.vendor.build.date=`date`>>$@
	$(hide) echo ro.vendor.build.date.utc=`date +%s`>>$@
	$(hide) echo ro.vendor.build.fingerprint="$(BUILD_FINGERPRINT)">>$@
endif

# ----------------------------------------------------------------

# -----------------------------------------------------------------
# sdk-build.prop
#
# There are certain things in build.prop that we don't want to
# ship with the sdk; remove them.

# This must be a list of entire property keys followed by

=== debian/changelog ===
android-platform-build (1:6.0.1+r16-4) unstable; urgency=medium

  * d/rules: Split build targets of indep and arch (Closes: #826855)

 -- Kai-Chung Yan <seamlikok@gmail.com>  Tue, 14 Jun 2016 00:21:08 +0800

android-platform-build (1:6.0.1+r16-3) unstable; urgency=medium

  * Team upload.

  [ Kai-Chung Yan ]
  * Remove unofficial architectures: mips64, armeb, arm
  * New package: android-logtags-tools
  * Standards-Version => 3.9.8
  * d/rules:
    - export DEB_BUILD_MAINT_OPTIONS = hardening=+all
    - Let dh_shlibdeps search multiarch android directory

 -- Markus Koschany <apo@debian.org>  Tue, 07 Jun 2016 12:41:21 +0200

android-platform-build (1:6.0.1+r16-2) unstable; urgency=medium

  * d/rules: BUILD_TOOLS_VERSION => 23.0.2
  * Add support of multi-arch

 -- Kai-Chung Yan <seamlikok@gmail.com>  Sat, 26 Mar 2016 00:39:11 +0800

android-platform-build (1:6.0.1+r16-1) unstable; urgency=medium

  * New upstream release
  * d/rules: Do not execute build commands on other architectures
  * android-platform-build-headers.install: Add core/version_defaults.mk
  * d/control: Limit zipalign BD to [amd64 i386]

 -- Kai-Chung Yan <seamlikok@gmail.com>  Fri, 12 Feb 2016 15:05:23 +0800

android-platform-build (1:6.0.0+r26-1) unstable; urgency=medium

  * Upload without any build profiles
    - Restore <!stage1> sections in d/control
    - Remove DEB_BUILD_PROFILES in d/rules
  * d/control:
    - Standards-Version => 3.9.7
    - zipalign: Architectures limit to amd64 & i386

 -- Kai-Chung Yan <seamlikok@gmail.com>  Mon, 08 Feb 2016 19:52:51 +0800

android-platform-build (1:6.0.0+r26-1~stage1.1) unstable; urgency=medium

  * upload to unstable

 -- Hans-Christoph Steiner <hans@eds.org>  Sun, 07 Feb 2016 22:01:12 +0100

android-platform-build (1:6.0.0+r26-1~stage1) experimental; urgency=low

  * New upstream release
  * stage1 upload
    - Remove <!stage1> sections in d/control
    - export DEB_BUILD_PROFILES = stage1 in d/rules
  * Change version scheme to follow Android release tags
  * d/control:
    - Add myself to Uploaders
    - Add (build-)depends on zopfli (>= 1.0.1-3)
    - Update zipalign package description
    - Add build-depends on dh-exec
  * Remove unused package android-libhost(-dev)
  * Rename android-globalconfig-dev to android-platform-build-headers
  * Make android-platform-build-headers for stage1
  * Makefiles independent from Quilt
  * d/zipalign.links: Install symlink to Android SDK home
  * New fix_zopfli_usage.diff: zopfli is written in C but zipalign is in C++
  * New fix_zipalign_typo.diff: Fix a typo in zipalign's output messages
  * Install tools/zipalign/README.txt as docs

 -- Kai-Chung Yan <seamlikok@gmail.com>  Fri, 13 Nov 2015 13:04:53 +0800

android-platform-build (21-4) unstable; urgency=low

  * include Breaks: and Replaces: to allow for proper upgrading

 -- Hans-Christoph Steiner <hans@eds.org>  Tue, 25 Nov 2014 12:53:11 +0100

android-platform-build (21-3) unstable; urgency=low

  * add versions to shlibs so dh can do dep detection
  * link libhost with $(CXX) since it includes a .cpp file
  * Standards-Version: 3.9.6

 -- Hans-Christoph Steiner <hans@eds.org>  Tue, 18 Nov 2014 15:15:37 +0100

android-platform-build (21-2) unstable; urgency=low

  * include pseudolocalize in libhost

 -- Hans-Christoph Steiner <hans@eds.org>  Wed, 01 Oct 2014 12:57:27 -0400

android-platform-build (21-1) unstable; urgency=low

  * Initial release. (Closes: #747926)

 -- Hans-Christoph Steiner <hans@eds.org>  Tue, 15 Jul 2014 17:06:00 -0400

=== debian/control ===
Source: android-platform-build
Section: devel
Priority: optional
Maintainer: Android tools Maintainer <android-tools-devel@lists.alioth.debian.org>
Uploaders: Kai-Chung Yan <seamlikok@gmail.com>,
           Hans-Christoph Steiner <hans@eds.org>
Build-Depends: android-libandroidfw-dev (>= 6.0.1+r16~) [amd64 i386] <!stage1>,
               android-liblog-dev (>= 1:6.0.0+r26~) [amd64 i386] <!stage1>,
               android-libutils-dev (>= 1:6.0.0+r26~) [amd64 i386] <!stage1>,
               debhelper (>= 9.20141010),
               dh-exec,
               dpkg-dev (>= 1.17.14),
               libzopfli-dev (>= 1.0.1-3) [amd64 i386] <!stage1>,
               zlib1g-dev [amd64 i386] <!stage1>
Build-Depends-Indep: pandoc
Standards-Version: 3.9.8
Homepage: https://android.googlesource.com/platform/build
Vcs-Git: https://anonscm.debian.org/git/android-tools/android-platform-build.git
Vcs-Browser: https://anonscm.debian.org/cgit/android-tools/android-platform-build.git

Package: android-platform-build-headers
Section: libdevel
Architecture: amd64 i386 arm64 armel armhf mips mipsel mips64el
Depends: ${misc:Depends}
Description: Shared headers and makefiles in AOSP repository platform/build
 This package contains the following:
 .
 * AndroidConfig.h for x86, MIPS and ARM
 * version_defaults.mk for referencing API Level

Package: zipalign
Architecture: amd64 i386
Build-Profiles: <!stage1>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Zip archive alignment tool
 zipalign is an archive alignment tool that provides important optimization to
 Android application (.apk) files. The purpose is to ensure that all
 uncompressed data starts with a particular alignment relative to the start of
 the file.

Package: android-logtags-tools
Architecture: all
Depends: python, ${misc:Depends}
Description: Tools from AOSP that process event-log-tags files
 This package contains Python scripts from AOSP repository platform/build that
 process event-log-tags (.logtags) files. It contains:
   * java-event-log-tags
   * merge-event-log-tags
 They are used in the process of building the Android platform framework
 "android.jar".

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include debian/detect_arch.mk

export DEB_HOST_ARCH_CPU
export DEB_HOST_MULTIARCH
UPSTREAM_TAG = android-$(subst +,_,$(DEB_VERSION_UPSTREAM))
# See sdk/build_tools_source.prop_template in platform/development
export BUILD_TOOLS_VERSION = 23.0.2
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
    BUILD_COMMANDS = make -f debian/zipalign.mk
    CLEAN_COMMANDS = make clean -f debian/zipalign.mk
  endif
endif

debian/java-event-log-tags.1:
	pandoc -s -o debian/java-event-log-tags.1 debian/java-event-log-tags.1.md

debian/merge-event-log-tags.1:
	pandoc -s -o debian/merge-event-log-tags.1 debian/merge-event-log-tags.1.md

%:
	dh $@

override_dh_auto_build-arch:
	$(BUILD_COMMANDS)

override_dh_auto_build-indep: debian/java-event-log-tags.1 debian/merge-event-log-tags.1

override_dh_auto_clean:
	$(CLEAN_COMMANDS)
	dh_auto_clean
	$(RM) debian/java-event-log-tags.1 debian/merge-event-log-tags.1

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/android -l/usr/lib/$(DEB_HOST_MULTIARCH)/android

get-orig-source: $(UPSTREAM_TAG).tar.gz
	mk-origtargz --repack --compression xz $<

$(UPSTREAM_TAG).tar.gz:
	wget https://android.googlesource.com/platform/build/+archive/$(UPSTREAM_TAG).tar.gz

## android-platform-build 6.0.1+r55

=== debian/changelog ===
android-platform-build (1:6.0.1+r55-2) unstable; urgency=medium

  * include `ziptime` from git via a patch

 -- Hans-Christoph Steiner <hans@eds.org>  Fri, 02 Sep 2016 21:18:34 +0200

android-platform-build (1:6.0.1+r55-1) unstable; urgency=medium

  * upload final stage

 -- Hans-Christoph Steiner <hans@eds.org>  Fri, 02 Sep 2016 14:48:02 +0200

android-platform-build (1:6.0.1+r55-1~stage1.1) unstable; urgency=medium

  [ Chirayu Desai ]
  * d/control: Move pandoc to B-D

  [ Kai-Chung Yan (殷啟聰) ]
  * d/rules: Let d/zipalign.1 only generated on specific architectures
  * d/rules: get-orig-source makes use of d/watch

 -- Chirayu Desai <chirayudesai1@gmail.com>  Fri, 02 Sep 2016 14:22:09 +0200

android-platform-build (1:6.0.1+r55-1~stage1) unstable; urgency=medium

  [ Chirayu Desai ]
  * New upstream release.
  * debian: Add watch file for usage with uscan
  * debian/watch: recompress using xz
  * Don't install core/version_defaults.mk
  * Define NDEBUG for c/cpp files

  [ Kai-Chung Yan ]
  * d/detect_arch.mk: Use DEB_HOST_ARCH instead of DEB_HOST_ARCH_CPU to detect
    architectures. This fixes FTBFS on ARM architectures.
  * d/rules: No longer export DEB_BUILD_MAINT_OPTIONS = hardening=+all as
    bindnow and pie will be default in Stretch

  [ Hans-Christoph Steiner ]
  * stage1 upload: export DEB_BUILD_PROFILES = stage1 in debian/rules

 -- Kai-Chung Yan <seamlikok@gmail.com>  Wed, 24 Aug 2016 18:55:08 +0800

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Priority: optional
 Maintainer: Android tools Maintainer <android-tools-devel@lists.alioth.debian.org>
 Uploaders: Kai-Chung Yan <seamlikok@gmail.com>,
-           Hans-Christoph Steiner <hans@eds.org>
-Build-Depends: android-libandroidfw-dev (>= 6.0.1+r16~) [amd64 i386] <!stage1>,
-               android-liblog-dev (>= 1:6.0.0+r26~) [amd64 i386] <!stage1>,
-               android-libutils-dev (>= 1:6.0.0+r26~) [amd64 i386] <!stage1>,
-               debhelper (>= 9.20141010),
+           Hans-Christoph Steiner <hans@eds.org>,
+           Chirayu Desai <chirayudesai1@gmail.com>
+Build-Depends: debhelper (>= 9.20141010),
                dh-exec,
                dpkg-dev (>= 1.17.14),
-               libzopfli-dev (>= 1.0.1-3) [amd64 i386] <!stage1>,
-               zlib1g-dev [amd64 i386] <!stage1>
-Build-Depends-Indep: pandoc
+               android-libandroidfw-dev (>= 1:6.0.1+r55~) [amd64 i386],
+               android-liblog-dev (>= 1:6.0.1+r55~) [amd64 i386],
+               android-libutils-dev (>= 1:6.0.1+r55~) [amd64 i386],
+               libzopfli-dev (>= 1.0.1-3) [amd64 i386],
+               zlib1g-dev [amd64 i386],
+               pandoc
 Standards-Version: 3.9.8
 Homepage: https://android.googlesource.com/platform/build
 Vcs-Git: https://anonscm.debian.org/git/android-tools/android-platform-build.git
@@ -26,17 +27,26 @@
  This package contains the following:
  .
  * AndroidConfig.h for x86, MIPS and ARM
- * version_defaults.mk for referencing API Level
 
 Package: zipalign
 Architecture: amd64 i386
-Build-Profiles: <!stage1>
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Zip archive alignment tool
  zipalign is an archive alignment tool that provides important optimization to
  Android application (.apk) files. The purpose is to ensure that all
  uncompressed data starts with a particular alignment relative to the start of
  the file.
+
+Package: ziptime
+Architecture: amd64 i386
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Zip archive timestamp remover
+ ziptime normalizes the timestamps in the header of a Zip file.  It
+ was created as part of the Android SDK to help make reproducible
+ builds of Android application (.apk) files. It replaces all
+ timestamps in the Zip headers with a static time (Jan 1 2008). The
+ extra fields are not changed, so you'll need to use the -X option to
+ zip so that it doesn't create the 'universal time' extra.
 
 Package: android-logtags-tools
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include debian/detect_arch.mk

export DEB_HOST_ARCH_CPU
export DEB_HOST_MULTIARCH
UPSTREAM_TAG = android-$(subst +,_,$(DEB_VERSION_UPSTREAM))
# See sdk/build_tools_source.prop_template in platform/development
export BUILD_TOOLS_VERSION = 23.0.2
export DEB_CFLAGS_MAINT_APPEND = -DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND = -DNDEBUG

ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH)),)
  ARCH_COMPONENTS = zipalign debian/zipalign.1 ziptime debian/ziptime.1
endif

debian/java-event-log-tags.1:
	pandoc -s -o $@ debian/java-event-log-tags.1.md

debian/merge-event-log-tags.1:
	pandoc -s -o $@ debian/merge-event-log-tags.1.md

zipalign:
	make -f debian/zipalign.mk

debian/zipalign.1:
	pandoc -s -o $@ debian/zipalign.1.md

ziptime:
	make -f debian/ziptime.mk

debian/ziptime.1:
	pandoc -s -o $@ debian/ziptime.1.md

%:
	dh $@

override_dh_auto_build-arch: $(ARCH_COMPONENTS)

override_dh_auto_build-indep: debian/java-event-log-tags.1 debian/merge-event-log-tags.1

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/*.1
	make clean -f debian/zipalign.mk
	make clean -f debian/ziptime.mk

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/android -l/usr/lib/$(DEB_HOST_MULTIARCH)/android

get-orig-source: $(UPSTREAM_TAG).tar.gz
	uscan --download-current-version --force-download

## android-platform-build 7.0.0+r1

=== debian/changelog ===
android-platform-build (1:7.0.0+r1-2) unstable; urgency=medium

  * Upload to unstable
  * d/control: Unify the maintainer name to "Android Tools Maintainers"

 -- Kai-Chung Yan <seamlikok@gmail.com>  Thu, 08 Dec 2016 22:15:32 +0800

android-platform-build (1:7.0.0+r1-1) experimental; urgency=medium

  * New upstream release
  * No longer provide `AndroidConfig.h`: Dropped by upstream
  * Enable builds for ARM & MIPS
  * Set the dynamic `BUILD_TOOLS_VERSION` to `debian`
  * Drop include_ziptime.patch: ziptime is included upstream
  * Update to debhelper 10

 -- Kai-Chung Yan <seamlikok@gmail.com>  Tue, 11 Oct 2016 21:22:09 +0800

android-platform-build (1:6.0.1+r55-3) unstable; urgency=medium

  * add new binary packages: signapk and signtos
  * remove unnecessary linked libs from ziptime

 -- Hans-Christoph Steiner <hans@eds.org>  Mon, 10 Oct 2016 19:37:55 +0200

=== debian/control ===
Source: android-platform-build
Section: devel
Priority: optional
Maintainer: Android Tools Maintainers <android-tools-devel@lists.alioth.debian.org>
Uploaders: Kai-Chung Yan <seamlikok@gmail.com>,
           Hans-Christoph Steiner <hans@eds.org>,
           Chirayu Desai <chirayudesai1@gmail.com>
Build-Depends: debhelper (>= 10),
               android-libandroidfw-dev (>= 1:7.0.0+r1) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
               android-liblog-dev (>= 1:7.0.0+r1) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
               android-libutils-dev (>= 1:7.0.0+r1) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
               default-jdk-headless | default-jdk,
               javahelper,
               libbcprov-java,
               libbcpkix-java,
               libzopfli-dev (>= 1.0.1-3) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
               zlib1g-dev [amd64 i386 armel armhf arm64 mips mipsel mips64el],
               pandoc
Standards-Version: 3.9.8
Homepage: https://android.googlesource.com/platform/build
Vcs-Git: https://anonscm.debian.org/git/android-tools/android-platform-build.git
Vcs-Browser: https://anonscm.debian.org/cgit/android-tools/android-platform-build.git

Package: android-platform-build-headers
Section: libdevel
Architecture: amd64 i386 armel armhf arm64 mips mipsel mips64el
Depends: ${misc:Depends}
Description: Transitional dummy package
 This package is for transitional only, feel free to remove it.

Package: zipalign
Architecture: amd64 i386 armel armhf arm64 mips mipsel mips64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Zip archive alignment tool
 zipalign is an archive alignment tool that provides important optimization to
 Android application (.apk) files. The purpose is to ensure that all
 uncompressed data starts with a particular alignment relative to the start of
 the file.

Package: ziptime
Architecture: amd64 i386 armel armhf arm64 mips mipsel mips64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Zip archive timestamp remover
 ziptime normalizes the timestamps in the header of a Zip file.  It
 was created as part of the Android SDK to help make reproducible
 builds of Android application (.apk) files. It replaces all
 timestamps in the Zip headers with a static time (Jan 1 2008). The
 extra fields are not changed, so you'll need to use the -X option to
 zip so that it doesn't create the 'universal time' extra.

Package: signapk
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}
Description: Command line tool for signing Android ZIP/JAR/APK
 signapk is a command line tool for signing ZIP files, including JARs,
 APKs, and Over-The-Air (OTA) updates, in a way compatible with
 Android's mincrypt verifier, using EC or RSA keys and SHA1 or
 SHA-256. The tool can additionally sign APKs using APK Signature
 Scheme v2. It is the standard tool used to sign APK and JAR files
 distributed as part of Android ROMs.

Package: signtos
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}
Description: Android signing tool for signing Trusty images
 Signs ARM Trusty images for use with operating systems that support
 it. Trusty is a set of software components supporting a Trusted
 Execution Environment (TEE) on mobile devices.  The key must be
 stored in PKCS8 format.

Package: android-logtags-tools
Architecture: all
Depends: python, ${misc:Depends}
Description: Tools from AOSP that process event-log-tags files
 This package contains Python scripts from AOSP repository platform/build that
 process event-log-tags (.logtags) files. It contains:
   * java-event-log-tags
   * merge-event-log-tags
 They are used in the process of building the Android platform framework
 "android.jar".

## android-platform-build 7.0.0+r33

=== Makefile ===
--- 
+++ 
@@ -47,6 +47,20 @@
 unique_product_copy_files_destinations :=
 
 # -----------------------------------------------------------------
+# Define rules to copy headers defined in copy_headers.mk
+# If more than one makefile declared a header, print a warning,
+# then copy the last one defined. This matches the previous make
+# behavior.
+$(foreach dest,$(ALL_COPIED_HEADERS), \
+    $(eval _srcs := $(ALL_COPIED_HEADERS.$(dest).SRC)) \
+    $(eval _src := $(word $(words $(_srcs)),$(_srcs))) \
+    $(if $(call streq,$(_src),$(_srcs)),, \
+        $(warning Duplicate header copy: $(dest)) \
+	$(warning Defined in: $(ALL_COPIED_HEADERS.$(dest).MAKEFILE))) \
+    $(eval $(call copy-one-header,$(_src),$(dest))))
+all_copied_headers: $(ALL_COPIED_HEADERS)
+
+# -----------------------------------------------------------------
 # docs/index.html
 ifeq (,$(TARGET_BUILD_APPS))
 gen := $(OUT_DOCS)/index.html
@@ -80,9 +94,9 @@
 	$(hide) echo "#" >> $@; \
 	        echo "# BOOTIMAGE_BUILD_PROPERTIES" >> $@; \
 	        echo "#" >> $@;
-	$(hide) echo ro.bootimage.build.date=`date`>>$@
-	$(hide) echo ro.bootimage.build.date.utc=`date +%s`>>$@
-	$(hide) echo ro.bootimage.build.fingerprint="$(BUILD_FINGERPRINT)">>$@
+	$(hide) echo ro.bootimage.build.date=`$(DATE_FROM_FILE)`>>$@
+	$(hide) echo ro.bootimage.build.date.utc=`$(DATE_FROM_FILE) +%s`>>$@
+	$(hide) echo ro.bootimage.build.fingerprint="$(BUILD_FINGERPRINT_FROM_FILE)">>$@
 	$(hide) build/tools/post_process_props.py $@
 
 # -----------------------------------------------------------------
@@ -114,7 +128,7 @@
 BUILD_VERSION_TAGS := $(subst $(space),$(comma),$(sort $(BUILD_VERSION_TAGS)))
 
 # A human-readable string that descibes this build in detail.
-build_desc := $(TARGET_PRODUCT)-$(TARGET_BUILD_VARIANT) $(PLATFORM_VERSION) $(BUILD_ID) $(BUILD_NUMBER) $(BUILD_VERSION_TAGS)
+build_desc := $(TARGET_PRODUCT)-$(TARGET_BUILD_VARIANT) $(PLATFORM_VERSION) $(BUILD_ID) $(BUILD_NUMBER_FROM_FILE) $(BUILD_VERSION_TAGS)
 $(intermediate_system_build_prop): PRIVATE_BUILD_DESC := $(build_desc)
 
 # The string used to uniquely identify the combined build and product; used by the OTA server.
@@ -122,7 +136,7 @@
   ifneq ($(filter eng.%,$(BUILD_NUMBER)),)
     # Trim down BUILD_FINGERPRINT: the default BUILD_NUMBER makes it easily exceed
     # the Android system property length limit (PROPERTY_VALUE_MAX=92).
-    BF_BUILD_NUMBER := $(USER)$(shell date +%m%d%H%M)
+    BF_BUILD_NUMBER := $(shell echo $${USER:0:6})$(shell $(DATE) +%m%d%H%M)
   else
     BF_BUILD_NUMBER := $(BUILD_NUMBER)
   endif
@@ -131,6 +145,9 @@
 ifneq ($(words $(BUILD_FINGERPRINT)),1)
   $(error BUILD_FINGERPRINT cannot contain spaces: "$(BUILD_FINGERPRINT)")
 endif
+
+$(shell mkdir -p $(PRODUCT_OUT) && echo $(BUILD_FINGERPRINT) > $(PRODUCT_OUT)/build_fingerprint.txt)
+BUILD_FINGERPRINT_FROM_FILE := $$(cat $(PRODUCT_OUT)/build_fingerprint.txt)
 
 # The string used to uniquely identify the system build; used by the OTA server.
 # This purposefully excludes any product-specific variables.
@@ -155,7 +172,7 @@
 
   # Dev. branches should have DISPLAY_BUILD_NUMBER set
   ifeq "true" "$(DISPLAY_BUILD_NUMBER)"
-    BUILD_DISPLAY_ID := $(BUILD_ID).$(BUILD_NUMBER) $(BUILD_KEYS)
+    BUILD_DISPLAY_ID := $(BUILD_ID).$(BUILD_NUMBER_FROM_FILE) $(BUILD_KEYS)
   else
     BUILD_DISPLAY_ID := $(BUILD_ID) $(BUILD_KEYS)
   endif
@@ -173,6 +190,12 @@
 endef
 
 BUILDINFO_SH := build/tools/buildinfo.sh
+
+# TARGET_BUILD_FLAVOR and ro.build.flavor are used only by the test harness to distinguish builds.
+TARGET_BUILD_FLAVOR := $(TARGET_PRODUCT)-$(TARGET_BUILD_VARIANT)
+ifdef SANITIZE_TARGET
+TARGET_BUILD_FLAVOR := $(TARGET_BUILD_FLAVOR)_asan
+endif
 
 ifdef TARGET_SYSTEM_PROP
 system_prop_file := $(TARGET_SYSTEM_PROP)
@@ -191,7 +214,7 @@
 		echo "import /oem/oem.prop $(prop)" >> $@;)
 endif
 	$(hide) TARGET_BUILD_TYPE="$(TARGET_BUILD_VARIANT)" \
-			TARGET_BUILD_FLAVOR="$(TARGET_PRODUCT)-$(TARGET_BUILD_VARIANT)" \
+			TARGET_BUILD_FLAVOR="$(TARGET_BUILD_FLAVOR)" \
 			TARGET_DEVICE="$(TARGET_DEVICE)" \
 			PRODUCT_NAME="$(TARGET_PRODUCT)" \
 			PRODUCT_BRAND="$(PRODUCT_BRAND)" \
@@ -202,7 +225,10 @@
 			PRIVATE_BUILD_DESC="$(PRIVATE_BUILD_DESC)" \
 			BUILD_ID="$(BUILD_ID)" \
 			BUILD_DISPLAY_ID="$(BUILD_DISPLAY_ID)" \
-			BUILD_NUMBER="$(BUILD_NUMBER)" \
+			DATE="$(DATE_FROM_FILE)" \
+			BUILD_NUMBER="$(BUILD_NUMBER_FROM_FILE)" \
+			BOARD_BUILD_SYSTEM_ROOT_IMAGE="$(BOARD_BUILD_SYSTEM_ROOT_IMAGE)" \
+			AB_OTA_UPDATER="$(AB_OTA_UPDATER)" \
 			PLATFORM_VERSION="$(PLATFORM_VERSION)" \
 			PLATFORM_SECURITY_PATCH="$(PLATFORM_SECURITY_PATCH)" \
 			PLATFORM_BASE_OS="$(PLATFORM_BASE_OS)" \
@@ -212,7 +238,7 @@
 			PLATFORM_VERSION_ALL_CODENAMES="$(PLATFORM_VERSION_ALL_CODENAMES)" \
 			BUILD_VERSION_TAGS="$(BUILD_VERSION_TAGS)" \
 			TARGET_BOOTLOADER_BOARD_NAME="$(TARGET_BOOTLOADER_BOARD_NAME)" \
-			BUILD_FINGERPRINT="$(BUILD_FINGERPRINT)" \
+			BUILD_FINGERPRINT="$(BUILD_FINGERPRINT_FROM_FILE)" \
 			$(if $(OEM_THUMBPRINT_PROPERTIES),BUILD_THUMBPRINT="$(BUILD_THUMBPRINT)") \
 			TARGET_BOARD_PLATFORM="$(TARGET_BOARD_PLATFORM)" \
 			TARGET_CPU_ABI_LIST="$(TARGET_CPU_ABI_LIST)" \
@@ -245,38 +271,3 @@
 ifeq (,$(filter true, $(TARGET_NO_KERNEL) $(TARGET_NO_RECOVERY)))
 INSTALLED_RECOVERYIMAGE_TARGET := $(PRODUCT_OUT)/recovery.img
 else
-INSTALLED_RECOVERYIMAGE_TARGET :=
-endif
-
-$(INSTALLED_BUILD_PROP_TARGET): $(intermediate_system_build_prop) $(INSTALLED_RECOVERYIMAGE_TARGET)
-	@echo "Target build info: $@"
-	$(hide) cat $(intermediate_system_build_prop) > $@
-ifdef INSTALLED_RECOVERYIMAGE_TARGET
-	$(hide) echo ro.expect.recovery_id=`cat $(RECOVERYIMAGE_ID_FILE)` >> $@
-endif
-
-# -----------------------------------------------------------------
-# vendor build.prop
-#
-# For verifying that the vendor build is what we thing it is
-ifdef BOARD_VENDORIMAGE_FILE_SYSTEM_TYPE
-INSTALLED_VENDOR_BUILD_PROP_TARGET := $(TARGET_OUT_VENDOR)/build.prop
-ALL_DEFAULT_INSTALLED_MODULES += $(INSTALLED_VENDOR_BUILD_PROP_TARGET)
-$(INSTALLED_VENDOR_BUILD_PROP_TARGET): $(INSTALLED_BUILD_PROP_TARGET)
-	@echo Target vendor buildinfo: $@
-	@mkdir -p $(dir $@)
-	$(hide) echo > $@
-	$(hide) echo ro.vendor.build.date=`date`>>$@
-	$(hide) echo ro.vendor.build.date.utc=`date +%s`>>$@
-	$(hide) echo ro.vendor.build.fingerprint="$(BUILD_FINGERPRINT)">>$@
-endif
-
-# ----------------------------------------------------------------
-
-# -----------------------------------------------------------------
-# sdk-build.prop
-#
-# There are certain things in build.prop that we don't want to
-# ship with the sdk; remove them.
-
-# This must be a list of entire property keys followed by

=== makeparallel/Makefile ===
# Copyright 2015 Google Inc. All rights reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Find source file location from path to this Makefile
MAKEPARALLEL_SRC_PATH := $(patsubst %/,%,$(dir $(lastword $(MAKEFILE_LIST))))
ifndef MAKEPARALLEL_SRC_PATH
  MAKEPARALLEL_SRC_PATH := .
endif

# Set defaults if they weren't set by the including Makefile
MAKEPARALLEL_CXX ?= $(CXX)
MAKEPARALLEL_LD ?= $(CXX)
MAKEPARALLEL_INTERMEDIATES_PATH ?= .
MAKEPARALLEL_BIN_PATH ?= .

MAKEPARALLEL_CXX_SRCS := \
	makeparallel.cpp

MAKEPARALLEL_CXXFLAGS := -Wall -Werror -MMD -MP

MAKEPARALLEL_CXX_SRCS := $(addprefix $(MAKEPARALLEL_SRC_PATH)/,\
	$(MAKEPARALLEL_CXX_SRCS))

MAKEPARALLEL_CXX_OBJS := $(patsubst $(MAKEPARALLEL_SRC_PATH)/%.cpp,$(MAKEPARALLEL_INTERMEDIATES_PATH)/%.o,$(MAKEPARALLEL_CXX_SRCS))

MAKEPARALLEL := $(MAKEPARALLEL_BIN_PATH)/makeparallel

ifeq ($(shell uname),Linux)
MAKEPARALLEL_LIBS := -lrt -lpthread
endif

# Rule to build makeparallel into MAKEPARALLEL_BIN_PATH
$(MAKEPARALLEL): $(MAKEPARALLEL_CXX_OBJS)
	@mkdir -p $(dir $@)
	$(MAKEPARALLEL_LD) -std=c++11 $(MAKEPARALLEL_CXXFLAGS) -o $@ $^ $(MAKEPARALLEL_LIBS)

# Rule to build source files into object files in MAKEPARALLEL_INTERMEDIATES_PATH
$(MAKEPARALLEL_CXX_OBJS): $(MAKEPARALLEL_INTERMEDIATES_PATH)/%.o: $(MAKEPARALLEL_SRC_PATH)/%.cpp
	@mkdir -p $(dir $@)
	$(MAKEPARALLEL_CXX) -c -std=c++11 $(MAKEPARALLEL_CXXFLAGS) -o $@ $<

makeparallel_clean:
	rm -rf $(MAKEPARALLEL)
	rm -rf $(MAKEPARALLEL_INTERMEDIATES_PATH)/*.o
	rm -rf $(MAKEPARALLEL_INTERMEDIATES_PATH)/*.d

.PHONY: makeparallel_clean

-include $(MAKEPARALLEL_INTERMEDIATES_PATH)/*.d

.PHONY: makeparallel_test
MAKEPARALLEL_TEST := MAKEFLAGS= MAKELEVEL= MAKEPARALLEL=$(MAKEPARALLEL) $(MAKE) -f Makefile.test test
MAKEPARALLEL_NINJA_TEST := MAKEFLAGS= MAKELEVEL= MAKEPARALLEL="$(MAKEPARALLEL) --ninja" $(MAKE) -f Makefile.test test
makeparallel_test: $(MAKEPARALLEL)
	@EXPECTED="-j1234" $(MAKEPARALLEL_TEST) -j1234
	@EXPECTED="-j123"  $(MAKEPARALLEL_TEST) -j123
	@EXPECTED="-j1"    $(MAKEPARALLEL_TEST) -j1
	@EXPECTED="-j1"    $(MAKEPARALLEL_TEST)

	@EXPECTED="-j1234" $(MAKEPARALLEL_NINJA_TEST) -j1234
	@EXPECTED="-j123"  $(MAKEPARALLEL_NINJA_TEST) -j123
	@EXPECTED="-j1"    $(MAKEPARALLEL_NINJA_TEST) -j1
	@EXPECTED="-j1"    $(MAKEPARALLEL_NINJA_TEST)
	@EXPECTED=""       $(MAKEPARALLEL_NINJA_TEST) -j
	@EXPECTED=""       $(MAKEPARALLEL_NINJA_TEST) -j -l

	@EXPECTED="-j1234" $(MAKEPARALLEL_TEST) --no-print-directory -j1234
	@EXPECTED="-j1234" $(MAKEPARALLEL_TEST) --no-print-directory -k -j1234
	@EXPECTED="-j1234" $(MAKEPARALLEL_TEST) -k -j1234
	@EXPECTED="-j1234" $(MAKEPARALLEL_TEST) -j1234 -k
	@EXPECTED="-j1234" $(MAKEPARALLEL_TEST) -kt -j1234

	@EXPECTED="-j1234"     $(MAKEPARALLEL_NINJA_TEST) --no-print-directory -j1234
	@EXPECTED="-j1234 -k0" $(MAKEPARALLEL_NINJA_TEST) --no-print-directory -k -j1234
	@EXPECTED="-j1234 -k0" $(MAKEPARALLEL_NINJA_TEST) -k -j1234
	@EXPECTED="-j1234 -k0" $(MAKEPARALLEL_NINJA_TEST) -j1234 -k
	@EXPECTED="-j1234 -k0" $(MAKEPARALLEL_NINJA_TEST) -kt -j1234

	@EXPECTED="-j1"    $(MAKEPARALLEL_TEST) A=-j1234
	@EXPECTED="-j1"    $(MAKEPARALLEL_TEST) A\ -j1234=-j1234
	@EXPECTED="-j1234" $(MAKEPARALLEL_TEST) A\ -j1234=-j1234 -j1234

	@EXPECTED="-j1234 args" ARGS="args" $(MAKEPARALLEL_TEST) -j1234

=== debian/changelog ===
android-platform-build (1:7.0.0+r33-1) unstable; urgency=medium

  * New upstream release

 -- Hans-Christoph Steiner <hans@eds.org>  Wed, 26 Apr 2017 19:41:04 +0200

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
            Hans-Christoph Steiner <hans@eds.org>,
            Chirayu Desai <chirayudesai1@gmail.com>
 Build-Depends: debhelper (>= 10),
-               android-libandroidfw-dev (>= 1:7.0.0+r1) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
-               android-liblog-dev (>= 1:7.0.0+r1) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
-               android-libutils-dev (>= 1:7.0.0+r1) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
+               android-libandroidfw-dev (>= 1:7.0.0+r33~) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
+               android-liblog-dev (>= 1:7.0.0+r33~) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
+               android-libutils-dev (>= 1:7.0.0+r33~) [amd64 i386 armel armhf arm64 mips mipsel mips64el],
                default-jdk-headless | default-jdk,
                javahelper,
                libbcprov-java,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/javahelper/java-vars.mk

export DEB_HOST_MULTIARCH
export DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -I/usr/include/android
export DEB_LDFLAGS_MAINT_APPEND = -fPIC

export CLASSPATH=/usr/share/java/bcprov.jar:/usr/share/java/bcpkix.jar

ifneq ($(filter amd64 i386 armel armhf arm64 mips mipsel mips64el,$(DEB_HOST_ARCH)),)
  ARCH_COMPONENTS = zipalign debian/zipalign.1 ziptime debian/ziptime.1
endif

debian/%.1: debian/%.1.md
	pandoc -s -o $@ $<

zipalign: debian/zipalign.mk
	make -f $<

ziptime: debian/ziptime.mk
	make -f $<

debian/signapk.1:
	pandoc -s -o $@ debian/signapk.1.md

debian/signtos.1:
	pandoc -s -o $@ debian/signtos.1.md

%:
	dh $@ --with javahelper

override_dh_auto_build-arch: $(ARCH_COMPONENTS)

override_dh_auto_build-indep: debian/java-event-log-tags.1 debian/merge-event-log-tags.1
override_dh_auto_build-indep: debian/signapk.1 debian/signtos.1

override_jh_build:
	jh_build --javacopts="-source 7" --no-javadoc \
		--main=com.android.signapk.SignApk signapk.jar tools/signapk/
	jh_build --javacopts="-source 7" --no-javadoc \
		--main=com.android.signtos.SignTos signtos.jar tools/signtos/

override_jh_exec:
	jh_exec --indep --package=signapk
	jh_exec --indep --package=signtos

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/*.1 *.jar
	make clean -f debian/zipalign.mk
	make clean -f debian/ziptime.mk

get-orig-source:
	uscan --download-current-version --force-download
